    def wrapper(*args, **kwargs):
        base_function(*args, **kwargs)
        for p, v in parameter_list:
            p(v)
def end_DC(d):
    #d['STATION'].ivvi.set_dacs_zero()
    pass
def measure_DC(d):
#     '''
#      keithley_1 (V)
#      keithley_2 (V)
#     NW current (A)
#     keithley_1 (V)
#     SET current (A)
#     keithley_2 (V)
#     lockin_1 X(V)
#     lockin_1 phase (deg)
#     NW conductance (2e^2/h)
#lockin_1 X(V)
#lockin_1 phase (deg)
#     '''
# keithley_1 (V)
#keithley_2 (V)

    '''
    keithley_1 (V)
    keithley_2 (V)
    lockin_1 X(V)
    lockin_1 phase (deg)
    lockin_1 processed
    '''

    #S1_gain = d['STATION'].RAP.S1_gain()
    #S2_gain = d['STATION'].RAP.S2_gain()
    #NW_gain = d['STATION'].RAP.NW_gain()
    
    #S1_res = d['STATION'].RAP.S1_fridge_resistance() + S1_gain*1e-3+2e3
    #S2_res = d['STATION'].RAP.S2_fridge_resistance() + S2_gain*1e-3+2e3
    #NW_res = d['STATION'].RAP.NW_fridge_resistance() + NW_gain*1e-4+100
    
    k1 = d['STATION'].keithley_1.amplitude()
    #k1_scaled = k1/NW_gain
    
    k2 = d['STATION'].keithley_2.amplitude()
    #k2_scaled = k2/S1_gain
    
    lockin1_x = d['STATION'].lockin_1.X()
    lockin1_p = d['STATION'].lockin_1.P()
    #if lockin1_x == 0:
    #    processed1 = 1e99
    #else:
    #    processed1 = d['STATION'].TI.NW_bias_lockin.get_latest() / (lockin1_x/NW_gain)-NW_res
    lockin1_processed = lockin1_x/Imeas/(amplitude_1/np.sqrt(2)-lockin1_x/Imeas*Rs)
    
    #lockin2_x = d['STATION'].lockin_2.X()
    #lockin2_p = d['STATION'].lockin_2.P()
    #if lockin2_x == 0:
    #    processed2 = 1e99
    #else:
    #    processed2 = d['STATION'].TI.S1_bias_lockin.get_latest() / (lockin2_x/S1_gain)-S1_res
    
    
    #return [k1, k2, lockin1_x, lockin1_p, lockin2_x, lockin2_p]
    return [k1, k2, lockin1_x, lockin1_p, lockin1_processed]
sweep1: {
set_function:
    def fun(x, p):
        parameter.set(x)
        return []

point_function:
            'point_function': lambda parameter:points,

unit: mV
label: Dac 2}

ivvi.dac1(1000)
ivvi.dac2(0)
Rs=23e3 #depends on the selected leads (18kOhm if both pads have 5kOhm)
Vrange=10e-3
Imeas=1e6
amplitude_1 = 20e-6  #Volt
lockin1_amplitude = amplitude_1*1e2/Vrange
lockin2_amplitude = amplitude_1*1e2/Vrange

V_start = -900
V_end = 300
n_steps = 300
#Loops 12 - 1781 - Device 1
#back gate 26&24 (15V/V), all other gates grounded
parameter_list = [[station.lockin_1.amplitude, lockin1_amplitude], [station.lockin_1.sensitivity, 0.001], [station.lockin_1.time_constant, 0.1], 
                  [station.lockin_2.amplitude, lockin2_amplitude], [station.lockin_2.sensitivity, 0.002], [station.lockin_2.time_constant, 1]]
pysweep.sweep(set_parameters_after(init_DC, parameter_list), end_DC, 
             measure_DC,
             pysweep.sweep_object(station.ivvi.dac2, np.linspace(V_start, V_end, n_steps))
             )
